osgDB::Archive Class Referenceabstract

`#include <Archive>`

Inheritance diagram for osgDB::Archive:

## Public Types

typedef osgDB::DirectoryContents | FileNameList
Public Types inherited from osgDB::ReaderWriter

enum

Features {
FEATURE_NONE = 0 , FEATURE_READ_OBJECT = 1<<0 , FEATURE_READ_IMAGE = 1<<1 , FEATURE_READ_HEIGHT_FIELD = 1<<2 ,
FEATURE_READ_NODE = 1<<3 , FEATURE_READ_SHADER = 1<<4 , FEATURE_WRITE_OBJECT = 1<<5 , FEATURE_WRITE_IMAGE = 1<<6 ,
FEATURE_WRITE_HEIGHT_FIELD = 1<<7 , FEATURE_WRITE_NODE = 1<<8 , FEATURE_WRITE_SHADER = 1<<9 , FEATURE_READ_SCRIPT = 1<<10 ,
FEATURE_WRITE_SCRIPT = 1<<11 , FEATURE_ALL
}

| Bit mask for setting up which feature types are available for read and/or write. More...
enum | ArchiveStatus { READ , WRITE , CREATE }
typedef std::map< std::string, std::string > | FormatDescriptionMap
typedef std::list< std::string > | FeatureList
typedef osgDB::Options | Options
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Archive ()
virtual | ~Archive ()
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | acceptsExtension (const std::string &) const
virtual void | close ()=0
virtual std::string | getArchiveFileName () const =0
virtual std::string | getMasterFileName () const =0
virtual bool | fileExists (const std::string &filename) const =0
virtual FileType | getFileType (const std::string &filename) const =0
virtual bool | getFileNames (FileNameList &fileNames) const =0
virtual DirectoryContents | getDirectoryContents (const std::string &dirName) const
virtual ReadResult | readObject (const std::string &, const Options *=NULL) const =0
virtual ReadResult | readImage (const std::string &, const Options *=NULL) const =0
virtual ReadResult | readHeightField (const std::string &, const Options *=NULL) const =0
virtual ReadResult | readNode (const std::string &, const Options *=NULL) const =0
virtual ReadResult | readShader (const std::string &, const Options *=NULL) const =0
virtual WriteResult | writeObject (const osg::Object &, const std::string &, const Options *=NULL) const =0
virtual WriteResult | writeImage (const osg::Image &, const std::string &, const Options *=NULL) const =0
virtual WriteResult | writeHeightField (const osg::HeightField &, const std::string &, const Options *=NULL) const =0
virtual WriteResult | writeNode (const osg::Node &, const std::string &, const Options *=NULL) const =0
virtual WriteResult | writeShader (const osg::Shader &, const std::string &, const Options *=NULL) const =0
Public Member Functions inherited from osgDB::ReaderWriter
| ReaderWriter ()
| ReaderWriter (const ReaderWriter &rw, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual | ~ReaderWriter ()
| META_Object (osgDB, ReaderWriter)
virtual const FormatDescriptionMap & | supportedProtocols () const
virtual const FormatDescriptionMap & | supportedExtensions () const
virtual const FormatDescriptionMap & | supportedOptions () const
virtual bool | acceptsProtocol (const std::string &protocol) const
virtual Features | supportedFeatures () const
virtual bool | fileExists (const std::string &filename, const Options *options) const
virtual ReadResult | openArchive (const std::string &, ArchiveStatus, unsigned int=4096, const Options *=NULL) const
virtual ReadResult | openArchive (std::istream &, const Options *=NULL) const
virtual ReadResult | readScript (const std::string &, const Options *=NULL) const
virtual WriteResult | writeScript (const osg::Script &, const std::string &, const Options *=NULL) const
virtual ReadResult | readObject (std::istream &, const Options *=NULL) const
virtual ReadResult | readImage (std::istream &, const Options *=NULL) const
virtual ReadResult | readHeightField (std::istream &, const Options *=NULL) const
virtual ReadResult | readNode (std::istream &, const Options *=NULL) const
virtual ReadResult | readShader (std::istream &, const Options *=NULL) const
virtual ReadResult | readScript (std::istream &, const Options *=NULL) const
virtual WriteResult | writeObject (const osg::Object &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeImage (const osg::Image &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeHeightField (const osg::HeightField &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeNode (const osg::Node &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeShader (const osg::Shader &, std::ostream &, const Options *=NULL) const
virtual WriteResult | writeScript (const osg::Script &, std::ostream &, const Options *=NULL) const
void | supportsProtocol (const std::string &fmt, const std::string &description)
void | supportsExtension (const std::string &ext, const std::string &description)
void | supportsOption (const std::string &opt, const std::string &description)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Additional Inherited Members

Static Public Member Functions inherited from osgDB::ReaderWriter
static FeatureList | featureAsString (Features feature)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const
Protected Attributes inherited from osgDB::ReaderWriter
FormatDescriptionMap | _supportedProtocols
FormatDescriptionMap | _supportedExtensions
FormatDescriptionMap | _supportedOptions
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

Base class for implementing database Archives. See src/osgPlugins/osga for an example of a concrete implementation.

## Member Typedef Documentation

## FileNameList

typedef osgDB::DirectoryContents osgDB::Archive::FileNameList

## Constructor & Destructor Documentation

## Archive()

osgDB::Archive::Archive | ( |  | ) |

## ~Archive()

virtual osgDB::Archive::~Archive | ( |  | ) |

virtual

## Member Function Documentation

## acceptsExtension()

virtual bool osgDB::Archive::acceptsExtension | ( | const std::string & |  | ) | const

inline virtual

Return true if ReaderWriter accepts specified file extension.

Reimplemented from osgDB::ReaderWriter.

## className()

virtual const char * osgDB::Archive::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## close()

virtual void osgDB::Archive::close | ( |  | ) |

pure virtual

close the archive.

## fileExists()

virtual bool osgDB::Archive::fileExists | ( | const std::string & | filename | ) | const

pure virtual

return true if file exists in archive.

## getArchiveFileName()

virtual std::string osgDB::Archive::getArchiveFileName | ( |  | ) | const

pure virtual

Get the file name which represents the archived file.

## getDirectoryContents()

virtual DirectoryContents osgDB::Archive::getDirectoryContents | ( | const std::string & | dirName | ) | const

virtual

return the contents of a directory. returns an empty array on any error.

## getFileNames()

virtual bool osgDB::Archive::getFileNames | ( | FileNameList & | fileNames | ) | const

pure virtual

Get the full list of file names available in the archive.

## getFileType()

virtual FileType osgDB::Archive::getFileType | ( | const std::string & | filename | ) | const

pure virtual

return type of file.

## getMasterFileName()

virtual std::string osgDB::Archive::getMasterFileName | ( |  | ) | const

pure virtual

Get the file name which represents the master file recorded in the Archive.

## libraryName()

virtual const char * osgDB::Archive::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## readHeightField()

virtual ReadResult osgDB::Archive::readHeightField | ( | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## readImage()

virtual ReadResult osgDB::Archive::readImage | ( | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## readNode()

virtual ReadResult osgDB::Archive::readNode | ( | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## readObject()

virtual ReadResult osgDB::Archive::readObject | ( | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## readShader()

virtual ReadResult osgDB::Archive::readShader | ( | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## writeHeightField()

virtual WriteResult osgDB::Archive::writeHeightField | ( | const osg::HeightField & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## writeImage()

virtual WriteResult osgDB::Archive::writeImage | ( | const osg::Image & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## writeNode()

virtual WriteResult osgDB::Archive::writeNode | ( | const osg::Node & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## writeObject()

virtual WriteResult osgDB::Archive::writeObject | ( | const osg::Object & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

## writeShader()

virtual WriteResult osgDB::Archive::writeShader | ( | const osg::Shader & | ,
|  | const std::string & | ,
|  | const Options * | = NULL ) const

pure virtual

Reimplemented from osgDB::ReaderWriter.

References NULL.

The documentation for this class was generated from the following file:

- Archive